Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentBasket.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentBasket.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentBasket.java	(revision 24993)
@@ -33,4 +33,5 @@
 import org.greenstone.gsdl3.util.GSXML;
 import org.greenstone.gsdl3.util.GSPath;
+import org.greenstone.gsdl3.util.UserContext;
 
 import java.net.InetAddress;
@@ -45,7 +46,5 @@
 import javax.swing.Timer;
 
-import java.io.FileOutputStream;
 import java.io.*;
-import java.io.IOException;
 
 import org.apache.log4j.*;
@@ -364,5 +363,10 @@
 		ArrayList tmp = new ArrayList();
 		tmp.add(id);
-		Element response = getDocumentMetadata(to, "en", "dumy", tmp.iterator());
+		
+		UserContext userContext = new UserContext();
+		userContext.setLanguage("en");
+		userContext.setUserID("dumy");
+		
+		Element response = getDocumentMetadata(to, userContext, tmp.iterator());
 		Element doc_node = (Element) response.getElementsByTagName(GSXML.DOC_NODE_ELEM).item(0);
 
@@ -539,10 +543,10 @@
 	}
 
-	private Element getDocumentMetadata(String to, String lang, String uid, Iterator ids)
+	private Element getDocumentMetadata(String to, UserContext userContext, Iterator ids)
 	{
 
 		// Build a request to obtain some document metadata
 		Element dm_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element dm_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element dm_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		dm_message.appendChild(dm_request);
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java	(revision 24993)
@@ -38,4 +38,5 @@
 import org.greenstone.gsdl3.util.GSPath;
 import org.greenstone.gsdl3.util.GSXML;
+import org.greenstone.gsdl3.util.UserContext;
 
 import org.w3c.dom.Element;
@@ -123,6 +124,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Get the list of documents to create
@@ -135,5 +135,5 @@
 			String collection = currentDoc.getAttribute(GSXML.COLLECTION_ATT);
 
-			_GSDM.documentCreate(oid, collection, lang, uid);
+			_GSDM.documentCreate(oid, collection, userContext);
 			if (_GSDM.checkError(result, DOCUMENT_CREATE))
 			{
@@ -155,6 +155,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Get the list of documents to delete
@@ -166,5 +165,5 @@
 			String collection = currentDoc.getAttribute(GSXML.COLLECTION_ATT);
 
-			_GSDM.documentDelete(oid, collection, lang, uid);
+			_GSDM.documentDelete(oid, collection, userContext);
 			if (_GSDM.checkError(result, DOCUMENT_DELETE))
 			{
@@ -186,6 +185,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Get the list of documents to duplicate
@@ -200,5 +198,5 @@
 			String operation = currentDoc.getAttribute("operation");
 
-			_GSDM.documentMoveOrDuplicate(oid, collection, newOID, newCollection, _GSDM.operationStringToInt(operation), false, lang, uid);
+			_GSDM.documentMoveOrDuplicate(oid, collection, newOID, newCollection, _GSDM.operationStringToInt(operation), false, userContext);
 			if (_GSDM.checkError(result, DOCUMENT_DUPLICATE))
 			{
@@ -220,6 +218,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Get the list of documents to duplicate
@@ -239,5 +236,5 @@
 			}
 
-			_GSDM.documentGetInformation(oid, collection, requestedInfo, lang, uid);
+			_GSDM.documentGetInformation(oid, collection, requestedInfo, userContext);
 			if (_GSDM.checkError(result, DOCUMENT_GET_INFORMATION))
 			{
@@ -259,6 +256,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Get the list of documents to duplicate
@@ -273,5 +269,5 @@
 			String operation = currentDoc.getAttribute("operation");
 
-			_GSDM.documentMoveOrDuplicate(oid, collection, newOID, newCollection, _GSDM.operationStringToInt(operation), true, lang, uid);
+			_GSDM.documentMoveOrDuplicate(oid, collection, newOID, newCollection, _GSDM.operationStringToInt(operation), true, userContext);
 			if (_GSDM.checkError(result, DOCUMENT_MOVE))
 			{
@@ -292,6 +288,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Get the list of documents to duplicate
@@ -304,5 +299,5 @@
 			String mergeOID = currentDoc.getAttribute("merge" + GSXML.NODE_ID_ATT);
 
-			_GSDM.documentMerge(oid, collection, mergeOID, lang, uid);
+			_GSDM.documentMerge(oid, collection, mergeOID, userContext);
 			if (_GSDM.checkError(result, DOCUMENT_MERGE))
 			{
@@ -324,6 +319,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Get the list of documents to duplicate
@@ -347,5 +341,5 @@
 			}
 
-			_GSDM.documentSplit(oid, collection, split, lang, uid);
+			_GSDM.documentSplit(oid, collection, split, userContext);
 			if (_GSDM.checkError(result, DOCUMENT_SPLIT))
 			{
@@ -367,6 +361,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
@@ -401,5 +394,5 @@
 					String subOperation = (String) keyValueMap.get("subOperation");
 
-					_GSDM.documentMoveOrDuplicate(origOID, origCollection, newOID, newCollection, _GSDM.operationStringToInt(subOperation), operation.equals("move"), lang, uid);
+					_GSDM.documentMoveOrDuplicate(origOID, origCollection, newOID, newCollection, _GSDM.operationStringToInt(subOperation), operation.equals("move"), userContext);
 
 					if (_GSDM.getErrorStatus() == GSDocumentModel.NO_ERROR && origCollection != null && !collectionsToBuild.contains(origCollection))
@@ -419,6 +412,6 @@
 					String subOperation = (String) keyValueMap.get("subOperation");
 
-					//_GSDM.documentCreate(oid, collection, lang, uid); <--- Maybe go back to this
-					_GSDM.documentXMLSetSection(oid, collection, this.doc.createElement(GSXML.DOCXML_SECTION_ELEM), _GSDM.operationStringToInt(subOperation), lang, uid);
+					//_GSDM.documentCreate(oid, collection, userContext); <--- Maybe go back to this
+					_GSDM.documentXMLSetSection(oid, collection, this.doc.createElement(GSXML.DOCXML_SECTION_ELEM), _GSDM.operationStringToInt(subOperation), userContext);
 
 					if (_GSDM.getErrorStatus() == GSDocumentModel.NO_ERROR && collection != null && !collectionsToBuild.contains(collection))
@@ -432,5 +425,5 @@
 					String collection = (String) keyValueMap.get("collection");
 
-					_GSDM.documentDelete(oid, collection, lang, uid);
+					_GSDM.documentDelete(oid, collection, userContext);
 
 					if (_GSDM.getErrorStatus() == GSDocumentModel.NO_ERROR && collection != null && !collectionsToBuild.contains(collection))
@@ -445,5 +438,5 @@
 					String newContent = (String) keyValueMap.get("text");
 					
-					_GSDM.documentXMLSetText(oid, collection, newContent, lang, uid);
+					_GSDM.documentXMLSetText(oid, collection, newContent, userContext);
 					
 					System.err.println(newContent);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Construct.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Construct.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Construct.java	(revision 24993)
@@ -174,5 +174,7 @@
 		String lang = request.getAttribute(GSXML.LANG_ATT);
 
-		systemRequest("delete", coll_name, null, lang);
+		UserContext userContext = new UserContext(request);
+		
+		systemRequest("delete", coll_name, null, userContext);
 
 		Element response = runCommand(request, GS2PerlConstructor.ACTIVATE);
@@ -227,5 +229,5 @@
 		// once have got here, we assume
 		// the first bit proceeded successfully, now reload the collection
-		systemRequest("reload", coll_name, status, lang); // this will append more messages to the status, and overwrite the error code att
+		systemRequest("reload", coll_name, status, userContext); // this will append more messages to the status, and overwrite the error code att
 		return response;
 
@@ -282,5 +284,8 @@
 			return response;
 		}
-		systemRequest("delete", coll_name, status, lang);
+		
+		UserContext userContext = new UserContext(request);
+
+		systemRequest("delete", coll_name, status, userContext);
 		return response;
 	}
@@ -319,5 +324,8 @@
 
 		String coll_name = (String) params.get(COL_PARAM);
-		systemRequest("reload", coll_name, status, lang);
+		
+		UserContext userContext = new UserContext(request);
+
+		systemRequest("reload", coll_name, status, userContext);
 		return response;
 
@@ -328,9 +336,9 @@
 	 * "delete" or "reload" response will be put into the status element
 	 */
-	protected void systemRequest(String action_name, String coll_name, Element status, String lang)
+	protected void systemRequest(String action_name, String coll_name, Element status, UserContext userContext)
 	{
 		// send the request to the MR
 		Element message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_SYSTEM, "", lang, "");
+		Element request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_SYSTEM, "", userContext);
 		message.appendChild(request);
 		Element command = this.doc.createElement(GSXML.SYSTEM_ELEM);
@@ -361,5 +369,5 @@
 			if (response == null)
 			{
-				t = this.doc.createTextNode(getTextString(action_name + ".configure_error", lang, args));
+				t = this.doc.createTextNode(getTextString(action_name + ".configure_error", userContext.getLanguage(), args));
 				status.setAttribute(GSXML.STATUS_ERROR_CODE_ATT, Integer.toString(GSStatus.ERROR));
 				status.appendChild(t);
@@ -368,5 +376,5 @@
 
 			// if we got here, we have succeeded!
-			t = this.doc.createTextNode(getTextString(action_name + ".success", lang, args));
+			t = this.doc.createTextNode(getTextString(action_name + ".success", userContext.getLanguage(), args));
 			status.setAttribute(GSXML.STATUS_ERROR_CODE_ATT, Integer.toString(GSStatus.SUCCESS));
 			status.appendChild(t);
@@ -441,5 +449,4 @@
 
 		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
 		String request_type = request.getAttribute(GSXML.TYPE_ATT);
 
